﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace InfragisticsExampleNotResizing {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e) {
            DummyRepository.Init();

            ultraGrid1.DataSource = DummyRepository.Tasks;
            ultraGrid2.DataSource = DummyRepository.Employees;
        }

        private void buttonAddTask_Click(object sender, EventArgs e) {

            Task tsk = (Task)ultraGrid1.ActiveRow.ListObject;

            Employee emp = (Employee)ultraGrid2.ActiveRow.ListObject;

            if (emp.Tasks == null) {
                emp.Tasks = new BindingList<Task>();
            }

            emp.Tasks.Add(tsk);

            ultraGrid1.DataSource = DummyRepository.Tasks;
            ultraGrid1.Rows.Refresh(Infragistics.Win.UltraWinGrid.RefreshRow.ReloadData, true);
            ultraGrid2.DataSource = DummyRepository.Employees;
            ultraGrid2.Rows.Refresh(Infragistics.Win.UltraWinGrid.RefreshRow.ReloadData, true);
            ultraGrid2.Rows.ExpandAll(true);
        }

        private void ultraGridPrescribedAndDelivered_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e) {

            Infragistics.Win.UltraWinGrid.UltraGrid grid = (Infragistics.Win.UltraWinGrid.UltraGrid)sender;

            grid.DisplayLayout.Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.False;
            grid.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
            grid.DisplayLayout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Single;

            Infragistics.Win.UltraWinGrid.UltraGridLayout layout = e.Layout;
            Infragistics.Win.UltraWinGrid.UltraGridOverride ov = layout.Override;

            ov.AllowColSizing = Infragistics.Win.UltraWinGrid.AllowColSizing.Free;
            layout.Bands[0].Override.RowSpacingAfter = 2;
            layout.Bands[0].Override.RowSpacingBefore = 3;

            foreach (var band in layout.Bands) {
                band.PerformAutoResizeColumns(false, Infragistics.Win.UltraWinGrid.PerformAutoSizeType.AllRowsInBand);
                foreach (var col in band.Columns) {
                    col.PerformAutoResize(Infragistics.Win.UltraWinGrid.PerformAutoSizeType.AllRowsInBand, true);
                }
            }

        }
    }
}
